#include "extdll.h"
#include <meta_api.h> // of course
#include "enginecallback.h"
#include "axn_plugin.h"
#include "cstrike.h"
#include "sdk_util.h"
#include "cbase.h"
#include "const.h"
#include "weaponinfo.h"
#include "progdefs.h"
#include "scriplib.h"
#include "entity.h"

#include "usrmsg.h"


bool CheckForSmokeGrenade(edict_t *pEdict,float radius)
{
	edict_t *pent=NULL;
	float distance;
	char item_name[40];
	while((pent=UTIL_FindEntityInSphere(pent, pEdict->v.origin, radius))!=NULL)
	{
		strcpy(item_name, STRING(pent->v.classname));
		if((strcmp("grenade", item_name)==0)&&(strcmp(STRING(pent->v.model), "models/w_smokegrenade.mdl")==0))
		{
			if(pent->v.velocity.Length()==0)
			{
				distance=(pent->v.origin - pEdict->v.origin).Length();
				if(distance<=radius)
					return true;
			}
		}
	} // end while loop
	return false;
}
void CS_PlayerThink(edict_t *pEntity)
{
	int index=ENTINDEX(pEntity);
	if(g_PlayerInfo[index].player_wait<=gpGlobals->time)
	{
		if(IsAlive(pEntity))
		{
			float radius=axn_smokeradius->value;
			if(radius>0)
			{
				if(CheckForSmokeGrenade(pEntity,radius))
				{
					if(pEntity->v.health>20)
					{
						int dmg=pEntity->v.health-20;
						if(dmg>5)
							dmg=5;
						// pEntity->v.dmg_inflictor=NULL;
						// pEntity->v.dmg_take=dmg;
						pEntity->v.health-=dmg;
						g_PlayerInfo[index].smkdmg+=dmg;
					}
					if(axn_smokegasp->value>0)
					{
						switch(RANDOM_LONG(0,1))
						{
						case 0: EMIT_SOUND_DYN2(pEntity, CHAN_VOICE, "player/gasp1.wav", RANDOM_FLOAT(0.3,0.8), RANDOM_FLOAT(1.0,1.5), 0, RANDOM_LONG(100,110)); break;
						case 1: EMIT_SOUND_DYN2(pEntity, CHAN_VOICE, "player/gasp2.wav", RANDOM_FLOAT(0.3,0.8), RANDOM_FLOAT(1.0,1.5), 0, RANDOM_LONG(100,110)); break;
						}
					}
				}
				else if(g_PlayerInfo[index].smkdmg>0)
				{
					int dmg=g_PlayerInfo[index].smkdmg;
					if(dmg>5)
						dmg=5;
					g_PlayerInfo[index].smkdmg-=dmg;
					pEntity->v.health+=dmg;
				}
			}
		}
		else
		{
			g_PlayerInfo[index].smkdmg=0;
		}
		g_PlayerInfo[index].player_wait=SetTimer(1);
	}
	
}
